# This is an example PKGBUILD file. Use this as a start to creating your own,
# and remove these comments. For more information, see 'man PKGBUILD'.
# NOTE: Please fill out the license field for your package! If it is unknown,
# then please put 'unknown'.

# Maintainer: Future Linux Team <future_linux@163.com>
pkgname=iana-etc
pkgver=20240813
pkgrel=1
pkgdesc="/etc/protocols and /etc/services provided by IANA"
arch=('x86_64')
url="https://www.iana.org/protocols"
license=('custom:none')
backup=(etc/protocols
	etc/services)
source=(https://www.iana.org/assignments/protocol-numbers/protocol-numbers.xml
	https://www.iana.org/assignments/service-names-port-numbers/service-names-port-numbers.xml)
sha256sums=(08090825eabfc99032614b2b6dbc36ebf64e39e3a2c8d5e0a3af1df4a6d4da66
	e05d5b388d1fc4a1f96a501ef713c8e55b08ff6c169f7d10b8159d600ed6f516)

package() {

	install -d ${pkgdir}/etc
	install -Dm644 service-names-port-numbers.xml ${pkgdir}/usr/share/iana-etc/port-numbers.iana
	install -Dm644 protocol-numbers.xml ${pkgdir}/usr/share/iana-etc/protocol-numbers.iana

	gawk -F"[<>]" '
BEGIN { print "# Full data: /usr/share/iana-etc/protocol-numbers.iana\n" }
(/<record/) { v=n="" }
(/<value/) { v=$3 }
(/<name/ && $3!~/ /) { n=$3 }
(/<\/record/ && n && v!="") { printf "%-12s %3i %s\n", tolower(n),v,n }
' protocol-numbers.xml > ${pkgdir}/etc/protocols

	gawk -F"[<>]" '
BEGIN { print "# Full data: /usr/share/iana-etc/port-numbers.iana\n" }
(/<record/) { n=u=p=c="" }
(/<name/ && !/\(/) { n=$3 }
(/<number/) { u=$3 }
(/<protocol/) { p=$3 }
(/Unassigned/ || /Reserved/ || /historic/) { c=1 }
(/<\/record/ && n && u && p && !c) { printf "%-15s %5i/%s\n", n,u,p }
' service-names-port-numbers.xml > ${pkgdir}/etc/services

}
